uniform int useNormalMap;

attribute vec3 tangent;
attribute vec3 bitangent;

varying vec3 eyeVec;
varying vec3 _eyeVec;
varying vec3 lightVec;
varying vec3 _lightVec;
varying vec3 halfVec;
varying vec3 normalVec;

void main() {	
  vec4 vertexPosition = gl_ModelViewMatrix * gl_Vertex;
  eyeVec = -vec3(vertexPosition);

  normalVec = normalize(gl_NormalMatrix * gl_Normal);

  if (useNormalMap == 1) {
	vec3 tangentEye = normalize(gl_NormalMatrix * tangent);
	vec3 bitangentEye = normalize(gl_NormalMatrix * bitangent);

	mat3 TBN = mat3(
      tangentEye.x, bitangentEye.x, normalVec.x,
      tangentEye.y, bitangentEye.y, normalVec.y,
	  tangentEye.z, bitangentEye.z, normalVec.z
	);
	
	eyeVec = TBN * eyeVec;
	_eyeVec = eyeVec;
	eyeVec = normalize(eyeVec);
	lightVec = TBN * vec3(gl_LightSource[1].position - vertexPosition);
	_lightVec = lightVec;
	lightVec = normalize(lightVec);
	halfVec = normalize(_lightVec + (TBN * vec3(-vertexPosition)));
  }
  else {
    _eyeVec = eyeVec;
	eyeVec = normalize(eyeVec);
    lightVec = vec3(gl_LightSource[1].position - vertexPosition);
	_lightVec = lightVec;
	lightVec = normalize(lightVec);
    halfVec = normalize(_lightVec + (vec3(-vertexPosition)));
  }
  
  gl_TexCoord[0] = gl_MultiTexCoord0;
  gl_Position = gl_ProjectionMatrix * vertexPosition; // ftransform()
  gl_FrontColor = gl_Color;
}