uniform sampler2D colorMap;

uniform float mapWidth;
uniform float mapHeight;

uniform int vert;

//float gaussKernel[31] = float[31] (1.0, 1.0, 1.0, 1.0, 2.0, 2.0, 2.0, 2.0, 2.0, 3.0, 3.0, 3.0, 3.0, 3.0, 3.0, 3.0, 3.0, 3.0, 3.0, 3.0, 3.0, 3.0, 2.0, 2.0, 2.0, 2.0, 2.0, 1.0, 1.0, 1.0, 1.0);

vec4 getColor(float x, float y) {
  return texture2D(colorMap, vec2(x, y));
}

void main() { 
  float gaussHalfSize = 15.0;//gaussKernel.length() / 2;
  
  vec4 sum = vec4(0,0,0,0);
  float div = 0.0;
  
  int gi = 0;
  float gif = 0;
  if (vert == 0) {
    float shiftX = 1.0/mapWidth;
    float texCoordX = gl_TexCoord[0].x;
    float texCoordY = gl_TexCoord[0].y;
    float x = texCoordX - gaussHalfSize*shiftX;
    
    for (float i = -gaussHalfSize; i <= gaussHalfSize; i++) {
      if (x >= 0.0 && x <= 1.0) {
	    gif = 1.0;
	    if (gi <= 8) { gif = 2.0; } else if (gi <= 21) { gif = 3.0; } else if (gi <= 26) { gif = 2.0; }
        sum += getColor(x, texCoordY) * gif;//gaussKernel[gi];
        div += gif;//gaussKernel[gi];
      }
      gi++;
      
      x += shiftX;
    }
  }
  else {
    float shiftY = 1.0/mapHeight;
    float texCoordX = gl_TexCoord[0].x;
    float texCoordY = gl_TexCoord[0].y;
    float y = texCoordY - gaussHalfSize*shiftY;
    
    for (float i = -gaussHalfSize; i <= gaussHalfSize; i++) {      
      if (y >= 0.0 && y <= 1.0) {
	    gif = 1.0;
	    if (gi <= 8) { gif = 2.0; } else if (gi <= 21) { gif = 3.0; } else if (gi <= 26) { gif = 2.0; }
        sum += getColor(texCoordX, y) * gif;//gaussKernel[gi];
        div += gif;//gaussKernel[gi];
      }
      gi++;
      
      y += shiftY;
    }
  }
  
  gl_FragColor = sum / div;
}
